routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
});



Auth::routes();

// Route::get('/index','HomeController@index')->name('index');
// Route::get('/home', 'HomeController@home')->name('home');
Route::get('/dash','HomeController@dash')->name('dash');
Route::get('/logout','HomeController@logout')->name('logout');


Route::get('/register', function(){
	return redirect('/home');
});

Route::get('/register','RegisterController@create')->name('register');
Route::post('/register','RegisterController@store');

Route::get('/content','ContentController@create')->name('content.create');
Route::post('/content','ContentController@store')->name('content.store');

Route::get('/index','ContentController@index')->name('content.index');
// Route::post('/update/{id}',['uses'=>'ContentController@update','as'=>'content.update']);
Route::post('update/{id}',['as'=> 'content.update','uses'=>'ContentController@update']);


Route::post('/delete/{id}',['uses'=>'ContentController@destroy','as'=>'content.destroy']);

Route::get('edit/{id}',['as'=> 'content.edit','uses'=>'ContentController@edit']);
 


Route::group(['namespace'=>'Admin','prefix'=>'admin','middleware'=>['auth:web']],
function()
{
Route::get('/','UserTypeController@index')->name('index');

Route::resource('usertype','UserTypeController');

Route::get('/usertype','UserTypeController@index')->name('admin.usertype');
Route::post('/usertype','UserTypeController@store')->name('usertype.store');


Route::get('/','RoleController@index')->name('index');

Route::resource('role','RoleController');
Route::get('/role','RoleController@index')->name('admin.role');


Route::get('/','AlbumController@index')->name('index');
Route::resource('album','AlbumController');
Route::get('/album','AlbumController@index')->name('admin.album');
Route::get('/album/{id}',['as'=> 'album.show','uses'=>'AlbumController@show']);
Route::get('edit/{id}',['as'=> 'album.edit','uses'=>'AlbumController@edit']);

// Route::post('update/{id}',['as'=> 'album.update','uses'=>'AlbumController@update']);
Route::post('album/{id}',['as'=> 'album.destroy','uses'=>'AlbumController@destroy']);



Route::get('/','PhotoController@index')->name('index');
Route::resource('/photo','PhotoController');
Route::get('/photo/{id}','PhotoController@index')->name('admin.photo');

Route::post('/photo-store/{id}',['as'=>'photo.store','uses'=>'PhotoController@store']);

Route::get('/photo-gallery/{id}','PhotoController@gallery')->name('admin.photo.gallery');
Route::get('/photo/{id}','PhotoController@show')->name('back.photos.index');
Route::get('edit/{id}',['as'=> 'photo.edit','uses'=>'PhotoController@edit']);

// Route::post('update/{id}',['as'=> 'photo.update','uses'=>'PhotoController@update']);

Route::post('photo/{id}',['as'=> 'photo.destroy()','uses'=>'PhotoController@destroy']);

});

app/Album.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;
use App\Photo;

class Album extends Model
{
    protected $table='albums';
    protected $fillable=[
    	'name','description','cover_image'
    ];
      public function Photos(){
    	return $this->hasMany('App\Photo');
    }
}

app/Http/Controllers/Admin/AlbumController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Album;


class AlbumController extends Controller
{


	public function index(){
		$albums=Album::with('Photos')->get();
		return view('back.album.index')->with('albums',$albums);	
	}
    public function create(){
    	$data=Album::get();
    	return view('back.album.create',compact('data'));
    }

    public function store(Request $request){
    	$this->validate($request,[
    		'title' =>'required',
    		'description'=>'required',
    		'cover_image' => 'image|max:1999',
    	]);


    	$filenameWithExt = $request->file('cover_image')->getClientOriginalName();

    	// get the filename only
    	$filename=pathinfo($filenameWithExt, PATHINFO_FILENAME);

    	 // get extension
    	$extension =$request->file('cover_image')->getClientOriginalExtension();


    	// create new file
    	$filenameToStore = $filename.'_'.time().'.'.$extension;

    	// upload image
    	$path= $request->file('cover_image')->storeAs('public/album_covers',$filenameToStore);

    // create album_cover
    	 Album::create([
    	  	'name'=> $request->title,
    		'description'=>$request->description,
    		'cover_image'=>$filenameToStore
    		]);
    	session()->flash('message',$request->title  .' album sucessfully saved....');

    	return redirect()->route('admin.album');

    }
    public function show(Request $request,$id){
    	$album=Album::with('Photos')->find($id);
    	return view('back.album.show')->with('album',$album);

    	// return redirect()->route('back.album.show')->with('album',$album);
}

   public function edit($id){
   	$album=Album::findorFail($id);

   	return view('back.album.edit',compact('album'));
   }

   public function update(Request $request,$id){
   	$message="Album updated sucessfully";
   		$this->validate($request,[
    		'title' =>'required',
    		'description'=>'required',
    		'cover_image' => 'image|max:1999',
    	
   	]);
   		$filenameWithExt = $request->file('cover_image')->getClientOriginalName();

    	// get the filename only
    	$filename=pathinfo($filenameWithExt, PATHINFO_FILENAME);

    	 // get extension
    	$extension =$request->file('cover_image')->getClientOriginalExtension();


    	// create new file
    	$filenameToStore = $filename.'_'.time().'.'.$extension;

    	// upload image
    	$path= $request->file('cover_image')->storeAs('public/album_covers',$filenameToStore);

   		Album::find($id)->update([
		'name'=>$request->title,
		'description'=>$request->description,
		'cover_image'=>$filenameToStore
   		

   	]);
      session()->flash('message',$request->title  .' album sucessfully updated....');
   		return redirect()->route('admin.album')->with('status',$message);
}

	public function destroy(Request $request,$id){
		// $message="Album deleted sucessfully";
   			$album=Album::findorFail($id);
   			$album->delete();
        session()->flash('message',' Album sucessfully deleted');
   			return redirect()->route('admin.album');
   		
}
}

resources/views/back/album/create.blade.php
@extends('back.layout.master')
  @section('content')
 <div class="content-wrapper">
    <!-- Content Header (Page header) -->
      <section class="content-header">
      <h1>
       Add Role
      </h1>
      <ol class="breadcrumb">
        <li><a href="#"><i class="fa fa-dashboard"></i> Home</a></li>
        <li><a href="#">Forms</a></li>
        <li class="active">General Elements</li>
      </ol>
    </section>
    <!-- Main content -->
    <section class="content">
      <div class="row">
        <div class="col-md-10">
          <div class="box box-primary">
           <form role="form" id="quickForm" method="post" action="{{route('album.store')}}" enctype="multipart/form-data">
          
              {{ csrf_field() }}
              <div class="box-body">
             
                  <div class="form-group">
                    <label for="title">Album Name</label>
                    <input type="text" name='title' class="form-control" id="title" placeholder="Enter the name of an album here">
                  </div>
               

                  <div class="box box-primary">
                    <div class="box-header">
                    <label for="description" >Description</label>
                     
                    <textarea name="description" class="form-control ckeditor form-control-lg"></textarea>
                  </div>
                </div>

                <div class="form-group">
                    <label for="cover_image" >Choose photo</label>
                    <input type="file" name='cover_image' class="form-control" id="cover_image">
                  
                </div>
                 
                </div>
              
              <div class="box-footer">
                <button type="submit" class="btn btn-primary">Submit</button>
              </div>
              </form>
           
        
            </div>
        
        </div>
     
      </div>
    </section>
   
  </div>

@endsection
                     

 

             

resources/views/back/album/edit.blade.php
@extends('back.layout.master')
  @section('content')
 <div class="content-wrapper">
    <!-- Content Header (Page header) -->
      <section class="content-header">
      <h1>
       Update Album
      </h1>
      <ol class="breadcrumb">
        <li><a href="#"><i class="fa fa-dashboard"></i> Home</a></li>
        <li><a href="#">Forms</a></li>
        <li class="active">General Elements</li>
      </ol>
    </section>
    <!-- Main content -->
    <section class="content">
      <div class="row">
        <div class="col-md-10">
          <div class="box box-primary">
           <form  method="post" action="{{route('album.update',$album->id)}}" enctype="multipart/form-data">
          
              {{ csrf_field() }}
               {{method_field('PUT')}}
              <div class="box-body">
             
                  <div class="form-group">
                    <label for="title">Album Name</label>
                    <input type="text" name='title' class="form-control" id="title" value="{{$album->name}}" placeholder="Enter the name of an album here">
                  </div>
               

                  <div class="box box-primary">
                    <div class="box-header">
                    <label for="description" >Description</label>
                     
                    <textarea name="description" value="{{$album->description}}" class="form-control ckeditor form-control-lg">{{$album->description}}</textarea>
                  </div>
                </div>

                <div class="form-group">
                    <label for="cover_image" >Choose photo</label>
                    <input type="file" name='cover_image' value="{{$album->cover_image}}" class="form-control" id="cover_image">{{$album->cover_image}}
                  
                </div>
                     


             

                 
                </div>
              
              <div class="box-footer">
                <button type="submit" class="btn btn-primary">Update</button>
              </div>
              </form>
        
            </div>
        
        </div>
     
      </div>
    </section>
   
  </div>

@endsection

resources/views/back/album/index.blade.php
@extends('back.layout.master')
@section('content')

@if(count($albums)>0)	
<?php
$colcount=count($albums);
$i=1;
?>

<div class="content-wrapper">
<div id="albums">

	<div class="row text-center">
		@foreach($albums as $album)
		@if($i == $colcount)
	
			<div class="col-md-4">
				
				<a href="{{route('album.show',$album->id)}}">
					<img class="thumbnail" src="{{url('storage/album_covers/ . $album->cover_image')}}" alt="Click to add photos"/>
				</a>
				<br>
				<h4>{{$album->name}}</h4>

                    <a href="{{route('album.edit',$album->id)}}" class="btn btn-success"><i class="fa fa-cogs"></i>Edit</a>
                      <a class="btn btn-secondary" style="border-color: none;">
                    <form action="{{route('album.destroy',$album->id)}}" method="POST" class="d-inline">

                      {{ csrf_field() }}
                  
                    <button class="btn btn-danger"><i class="fa fa-trash">Delete</i></button>
                    </form>
                </a>
				@else

				
				<div class="col-md-4">
		
					<a href="{{route('album.show',$album->id)}}">
						<img class="thumbnail" src="{{asset('/storage/album_covers/ . $album->cover_image')}}" alt="Click to add photos">
					</a>
					</br>
						<h4>{{$album->name}}</h4>
						  <a href="{{route('album.edit',$album->id)}}" class="btn btn-success"><i class="fa fa-cogs"></i>Edit</a>
						   <a class="btn btn-secondary" style="border-color: none;">
                    <form action="{{route('album.destroy',$album->id)}}" method="POST" class="d-inline">

                      {{ csrf_field() }}
                      {{method_field('DELETE')}}

                    <button class="btn btn-danger"><i class="fa fa-trash">Delete</i></button>
                    </form>
               </a>

						@endif
						@if($i%3==0)	




						
				</div>

			</div>
				<div class="row text-center">
					@else
				</div>
				@endif
				<?php $i++;?>
				@endforeach
			</div>
		
	</div>
	
</div>

@else
<p> No albums to display</p>
@endif
</div>

@endsection

resources/views/back/album/show.blade.php
@extends('back.layout.master')
@section('content')


<div class="content-wrapper">
<h3>{{$album->name}}</h3>
<a class="btn btn-primary" href="{{route('admin.album')}}" style="margin-bottom: 2%;">Go Back</a>
<a class="btn btn-success"  href="{{route('admin.photo.gallery',$album->id)}}" style="margin-bottom: 2%;">Upload Photo to album</a>

@if(count($album->photos)>0)	
<?php
$colcount=count($album->photos);
$i=1;
?> 


<div id="photos">

	<div class="row text-center">
		@foreach($album->photos as $photo)
		@if($i == $colcount)
		
			<div class="col-md-3">
				
				 <a href="{{route('back.photos.index',$photo->id)}}"> 
					<img class="thumbnail" src="{{asset('/storage/photos/($photo->id)/($photo->photo)')}}" >
				</a>
				<br>
				<h4>{{$photo->title}}</h4>
				@else
				<div class="col-md-4">
		
				<a href="{{route('back.photos.index',$photo->id)}}"> 
					<img class="thumbnail" src="{{asset('/storage/photos/($photo->id)/($photo->photo)')}}" >
				</a>
				<br>
				<h4>{{$photo->title}}</h4>
				
				@endif

				@if($i%3==0)	

				</div>
			</div>
				<div class="row text-center">
					@else
				</div>
				@endif
				<?php $i++;?>
				@endforeach
	
		
	</div>
	
</div>
 
@else
<p> No Photos to display</p>
@endif



</div>
@endsection